unit HmsAddonsIntfTypes;

interface

uses
  ActiveX;

const
 { IHmsScriptEditor.GetCapabilities }

  ecEditor    = 1;
  ecStatusBar = 2;
  ecMessages  = 4;

{ IHmsScriptFrame.ProcessCommand }

  ecUserFirst       = 1001; // Start of user-defined commands
  ecCompileScript    = ecUserFirst + 103;
  ecRunLine          = ecUserFirst + 100;
  ecRunScript        = ecUserFirst + 102;
  ecToggleBreakpoint = ecUserFirst + 101;
  ecEvaluate         = ecUserFirst + 104;
  ecWatches          = ecUserFirst + 105;

{ IHmsAddonTools.Update flags }

  ufCheckExistsOnly  = $01; //   
  ufIsHttpLink       = $02; //  - http-  zip- 
  ufIsLocalFile      = $04; //  -  zip- 
  ufIsInfoMessage    = $08; //  -  
  ufIsErrorMessage   = $10; //  -   
  ufIsWarningMessage = $20; //  - ,  

const
  CLASS_HmsAddonList: TGUID = '{1C6BC2D4-5AF8-4203-98D3-5D4CA48E6C6F}';

type
  IHmsAddonTools = interface(IDispatch)
  ['{C5B24BFB-1F30-4F8A-91AD-943B82D8A067}']
    function Setup(aOwner: THandle; var aReload: LongBool): HResult; safecall;
    function Update(var aFlags: Integer; var aResult: OleVariant): HResult; safecall;
  end;

  IHmsAddonList = interface(IDispatch)
  ['{A8F688A7-441E-4701-9EA0-9C591D0B997A}']
    function GetCount(var aCount: Integer): HResult; safecall;
    function GetAddonInfo(aIndex: Integer; var aClassID, aInterfaceID: TGUID;
        var aTitle, aDescription, aRequiredVersion, aCheckedOnVersion: OleVariant): HResult; safecall;
    function GetClassObject(const clsid: TGUID; const iid: TGUID; out pv: OleVariant): HResult; safecall;
    function CanUnloadNow: HResult; safecall;
  end;

  IHmsScriptFrame = interface(IDispatch)
  ['{D31B4638-9764-4A9A-9F5A-B4D0B519F402}']
    function AddWatch(const aExpression: OleVariant): HResult; safecall;

    function ChangeScriptName(const aScriptName: OleVariant): HResult; safecall;

    function CompileScript(const aScriptName, aScriptText: OleVariant; var aErrorMessage: OleVariant;
                           var aErrorLine, aErrorChar: Integer; var aResult: LongBool): HResult; safecall;

    function GenerateScriptDescriptions(var aXMLDescriptions: OleVariant): HResult; safecall;

    function GetCurrentState(var aRunning: LongBool;
                  var aCurrentSourceLine, aCurrentSourceChar: Integer): HResult; safecall;

    function IsBreakpointLine(aLine: Integer; var aResult: LongBool): HResult; safecall;
    function IsExecutableLine(aLine: Integer; var aResult: LongBool): HResult; safecall;

    function ProcessCommand(aCommand: Integer): HResult; safecall;

    function SolveExpression(const aExpression: OleVariant; var aResult: OleVariant): HResult; safecall;

    function ToggleBreakpoint(aLine: Integer): HResult; safecall;
  end;

{  THmsScriptMode = (
    smUnknown,
    smTranscoding,
    smWatchFoldersGroupName,
    smMediaInfo,
    smProcessMedia,
    smCreateFolderItems,
    smPodcastItemProperties,
    smMediaResourceLink,
    smWebMediaItems,
    smMimeType,
    smProcessMediaEvent,
    smCreatePodcastFeeds,
    smWebNavigation,
    smParsePlaylistFile,
    smAutoDetectDeviceType,
    smProcessMetadata,
    smDIDLLiteDescription,
    smHandleHTTPRequest); }

const
  IID_HmsScriptEditor = '{B43BB779-379D-4244-A53D-0AAC3863A0FB}';

  IID_HmsMainFormControl = '{6E86502E-15BC-4358-A4A1-29D97CDEF073}';

type
  IHmsScriptEditor = interface(IDispatch)
  [IID_HmsScriptEditor]
    function AddMessage(const aMessage: OleVariant): HResult; safecall;

    function CreateEditor(aParent: THandle; const aHmsScripter: IHmsScriptFrame;
                   aScriptMode: Integer; var aEditor: THandle): HResult; safecall;

    function DestroyEditor(aEditor: THandle): HResult; safecall;

    function GetCapabilities(var aCapabilities: Integer): HResult; safecall;

    function GetCurrentLine(var aLine: Integer): HResult; safecall;

    function GetScriptName(var aScriptName: OleVariant): HResult; safecall;
    function GetScriptText(var aText: OleVariant): HResult; safecall;
    function SetScriptName(const aScriptName: OleVariant): HResult; safecall;
    function SetScriptText(const aText: OleVariant): HResult; safecall;

    function GetModified(var aModified: LongBool): HResult; safecall;

    function InvalidateLine(aLineIndex: Integer): HResult; safecall;

    function Repaint: HResult; safecall;

    function GetCaretPos(var aLine, aChar: Integer): HResult; safecall;
    function SetCaretPos(aLine, aChar: Integer): HResult; safecall;

    function SetFocus: HResult; safecall;

    function SetRunning(aValue: LongBool): HResult; safecall;

    function SetSelText(const aText: OleVariant): HResult; safecall;

    function Setup: HResult; safecall;
  end;

  IHmsMainFormControl = interface(IDispatch)
  [IID_HmsMainFormControl]
    function CreateControl(aParent: THandle; const aReserved: IUnknown; var aControl: THandle): HResult; safecall;
    function DestroyControl(aControl: THandle): HResult; safecall;

    function GetCaption(var aCaption: OleVariant): HResult; safecall;
    function SetFocus: HResult; safecall;

    function ExecuteAction(const aActionName: OleVariant; const aActionParameters: OleVariant): HResult; safecall;
    function GetActionCount(var aCount: Integer): HResult; safecall;
    function GetActionInfo(aIndex: Integer; var aActionName, aActionTitle, aActionDescription: OleVariant): HResult; safecall;
  end;

implementation

end.
